--
-- CREATE_CURSOR
--

--
-- DELCARE cursor
--
CREATE DATABASE redhatdatabase;

COMMENT ON DATABASE redhatdatabase IS 'This is my database';

CREATE TABLE POINT_TBL2(f1 point);

COMMENT ON TABLE POINT_TBL2 IS 'This is my table';

INSERT INTO POINT_TBL2(f1) VALUES ('(0.0,0.0)');

INSERT INTO POINT_TBL2(f1) VALUES ('(-10.0,0.0)');

INSERT INTO POINT_TBL2(f1) VALUES ('(-3.0,4.0)');

INSERT INTO POINT_TBL2(f1) VALUES ('(5.1, 34.5)');

INSERT INTO POINT_TBL2(f1) VALUES ('(-5.0,-12.0)');

INSERT INTO POINT_TBL2(f1) VALUES ('(7.0,-3.0)');

BEGIN WORK;

/* DECLARE the CURSOR */
DECLARE cursor1 CURSOR FOR SELECT * FROM POINT_TBL2;

/* FETCH IN CURSOR */
FETCH FORWARD 3 IN cursor1;

FETCH 3 IN cursor1; -- default direction is FORWARD

FETCH BACKWARD 1 IN cursor1;

/* MOVE CURSOR position */

MOVE BACKWARD 5 IN cursor1;

MOVE FORWARD -2 IN cursor1;

FETCH FORWARD 100 IN cursor1;

MOVE BACKWARD 100 IN cursor1;

FETCH FORWARD IN cursor1; -- default row number

FETCH RELATIVE IN cursor1; -- fetch the next row

MOVE FORWARD 2 IN cursor1; 

FETCH BACKWARD IN cursor1; -- default row number

FETCH RELATIVE IN cursor1;  -- default row number

FETCH RELATIVE -1 IN cursor1; 

FETCH RELATIVE 2 IN cursor1; 

MOVE BACKWARD 100 IN cursor1;

FETCH FORWARD IN cursor1; -- default row number

FETCH ABSOLUTE IN cursor1; -- fetch the next row

MOVE FORWARD 2 IN cursor1; 

FETCH BACKWARD IN cursor1; -- default row number

FETCH ABSOLUTE IN cursor1;  -- default row number

FETCH ABSOLUTE -1 IN cursor1; 

FETCH ABSOLUTE 2 IN cursor1; 


/* CLOSE the CURSOR */
CLOSE cursor1;

COMMIT WORK;

BEGIN;
DECLARE cursor10 BINARY CURSOR FOR
SELECT * FROM POINT_TBL2 FOR READ ONLY;
CLOSE cursor10;
DECLARE cursor11 INSENSITIVE SCROLL CURSOR FOR
SELECT * FROM POINT_TBL2 FOR READ ONLY;
CLOSE cursor11;
DECLARE cursor12 SCROLL CURSOR FOR
SELECT * FROM POINT_TBL2 FOR READ ONLY;
CLOSE cursor12;
END;

DROP TABLE POINT_TBL2;

DROP DATABASE redhatdatabase;

